﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Collections.ObjectModel;
using System.ComponentModel;

namespace PanelBarExpandWhenSelected
{
    class DataModel
    {
        public ObservableCollection<Topic> Topics { get; set; }

        public DataModel()
        {
            Topics = GenerateTopics();
        }

        public ObservableCollection<Topic> GenerateTopics()
        {
            ObservableCollection<Topic> collection = new ObservableCollection<Topic>();
            for (int i = 0; i < 6; i++)
            {
                Topic top = new Topic(String.Format("Topic {0}",i));
                if(i==3)
                {
                    top.IsSelectedValue  = true;
                    top.IsExpandedvalue = true;
                }
                for (int j = 0; j < 5; j++)
                {
                    Topic subtopic = new Topic(String.Format("Subtopic {0}", j));
                    if (j == 4)
                    {
                        subtopic.IsSelectedValue = true;
                    }
                    top.SubTopics.Add(subtopic);
                }
                collection.Add(top);
            }
            return collection;
        }
    }

    public class Topic : INotifyPropertyChanged
    {
        public string Name { get; set; }

        private bool selected;
        public bool IsSelectedValue 
        {
            get
            {
                return selected;
            }
            set
            {
                selected = value;
                this.OnPropertyChanged("IsSelectedValue");
            }
        }

        private bool expanded;
        public bool IsExpandedvalue 
        {
            get
            {
                return expanded;
            }
            set
            {
                expanded = value;
                this.OnPropertyChanged("Expanded");
            }
        }
        public ObservableCollection<Topic> SubTopics { get; set; }

        public Topic(string name)
        {
            this.Name = name;
            this.IsSelectedValue = false;
            this.IsExpandedvalue = false;
            SubTopics = new ObservableCollection<Topic>();
        }

        public event PropertyChangedEventHandler PropertyChanged;
        private void OnPropertyChanged(string propertyName)
        {
            if (this.PropertyChanged != null)
            {
                this.PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }
    }
}
